#!/usr/bin/perl 
# $Header: /home/hiro/projects/dvr2/scripts/RCS/dvr2-ts2iepg.pl,v 1.3 2012/05/09 16:31:36 hiro Exp $
#===============================================================================
#
#         FILE:  dvr2-ts2iepg.pl
#
#        USAGE:  ./dvr2-ts2iepg.pl $TSFILE
#
#  DESCRIPTION:  Print out full iEPG paths for given TS files
#
#       AUTHOR:  Copyright (c) 2011-2012 Hiro Sugawara
#      CREATED:  10/24/11 09:33:01
#     REVISION:  ---
#===============================================================================

use strict;
use warnings;
use POSIX;
use File::Basename;

our $mydir	= dirname $0;
our $myname	= basename $0;
our $DVR2ROOT;
require "$mydir/dvr2-common.pl";

defined($ARGV[0]) || die "$myname: no argument\n";

foreach (@ARGV) {
	my $arg = $_;
	my $fbase = getIEPG($arg);
	my $file = sprintf "%s.iepg", (defined($fbase)	? $fbase
													: basename($arg, '.ts'));
	DIR:
	foreach my $dir ("$DVR2ROOT/recorded", "$DVR2ROOT/scheduled") {
		if (-e "$dir/$file") {
			print "$dir/$file\n";
			last DIR;
		}
	}
}
